// mpicc scatter-reduce.c -Wall -o test.x

#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <time.h>
#include <math.h>

int main( int argc, char *argv[] )
{
   int me=0, nProcs, i;
   double buffer, result=0;
   
   MPI_Init(&argc,&argv);
   MPI_Comm_rank( MPI_COMM_WORLD, &me );
   MPI_Comm_size( MPI_COMM_WORLD, &nProcs );
   
   srand48( (unsigned) me );
   buffer = pow(2,-me) * drand48();
   
   for( i=0; i<nProcs; i++ ){
      MPI_Reduce( &buffer, &result, 1, MPI_DOUBLE, MPI_SUM, i, MPI_COMM_WORLD );
      if( me == i )
         printf( "(%d) \t\t\tparRes:%.16g\n", me, result );
   }
      
   MPI_Finalize();
   return 0;
}


